diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 341d80797..598f5c9a9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -67,7 +67,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F), x, y, z);
                 renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + this.headThickness, y + this.headThickness + f1, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
@@ -75,7 +75,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 break;
 
             case UP: // TOP
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 + this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.8F, width);
                 renderHeadTopBottom(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, ((y - this.headThickness) + 1.0F) - f1, (y - this.headThickness) + 1.0F, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness * 0.6F, width);
@@ -85,7 +85,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
             case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness), x, y, z);
                 renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + this.headThickness, z + this.headThickness + f1, brightness * 0.5F, width);
@@ -97,7 +97,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.5 + this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.6F, width);
                 renderHeadNorthSouth(tessellator, x + 0.5 - this.shaftThickness/2, x + 0.5 + this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, ((z - this.headThickness) + 1.0F) - f1, (z - this.headThickness) + 1.0F, brightness * 0.5F, width);
@@ -109,7 +109,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F), x, y, z);
                 renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
                 renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
                 renderHeadEastWest(tessellator, x + this.headThickness, x + this.headThickness + f1, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
@@ -121,7 +121,7 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockLogicPistonHea
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
                 renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.5F, width);
                 renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 + this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 + this.shaftThickness/2, brightness, width);
                 renderHeadEastWest(tessellator, ((x - this.headThickness) + 1.0F) - f1, (x - this.headThickness) + 1.0F, y + 0.5 - this.shaftThickness/2, y + 0.5 + this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, z + 0.5 - this.shaftThickness/2, brightness * 0.6F, width);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index a1ce327dc..ec5131e25 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -55,7 +55,7 @@ public class BlockModelPumice<T extends BlockLogic> extends BlockModelStandard<T
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
         final double depthFixOffset = 0.001d;
-        AABB bounds = AABB.getTemporaryBB(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
+        AABB bounds = AABB.fromPool(depthFixOffset, depthFixOffset, depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset, 1 - depthFixOffset);
         renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
 
         renderBlocks.overbright = ob;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index 10f2577dd..0b8234b41 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -33,7 +33,7 @@ extends BlockModelStandard<T> {
             !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
 
-        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+        AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
 
         final float ropeThickness = (1 / 16f);
         final float knotThickness = (2 / 16f);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 7cf1a1471..9dd740c5a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -26,7 +26,7 @@ public class BlockModelSpikes<T extends BlockLogic> extends BlockModelStandard<T
             texture = renderBlocks.overrideBlockTexture;
         }
 
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.1875F, 1.0F), x, y, z);
 
         if(BlockLogicSpikes.isSpikesUp(metaData)) {
             float brightness = 1.0f;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
index 9e79395c1..0503af27e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStairs.java
@@ -39,7 +39,7 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
 
         float stepYOffset = vRotation > 0 ? 0.5f : 0.0f;
 
-        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+        AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
 
         if(hRotation == 0)
         {
@@ -85,9 +85,9 @@ public class BlockModelStairs<T extends BlockLogicStairs> extends BlockModelStan
             AABB bounds;
             if(l == 0)
             {
-                bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
+                bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
             } else {
-                bounds = AABB.getTemporaryBB(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
+                bounds = AABB.fromPool(0.5F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
             }
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
index c2c685dda..f35c93315 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
@@ -305,7 +305,7 @@ public class BlockModelStandard<T extends BlockLogic> extends BlockModel<T>{
     }
 
     public BlockModelStandard<T> withCustomItemBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ){
-        this.itemRenderBounds = AABB.getPermanentBB(minX, minY, minZ, maxX, maxY, maxZ);
+        this.itemRenderBounds = AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ).copyUnpooled();
         return this;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
index 09da687bc..4aa1ecb6e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/EntityCameraThirdPersonRear.java
@@ -44,19 +44,19 @@ public class EntityCameraThirdPersonRear
         double dz = (MathHelper.cos((yRot / 180F) * MathHelper.PI) * MathHelper.cos((xRot / 180F) * MathHelper.PI));
         double dy = (-MathHelper.sin((xRot / 180F) * MathHelper.PI));
 
-        double cameraDistance = Vec3.getTempVec3(x, y, z).distanceTo(Vec3.getTempVec3(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz)) - offset;
+        double cameraDistance = Vec3.fromPool(x, y, z).distanceTo(Vec3.fromPool(x - numSteps * dx, y - numSteps * dy, z - numSteps * dz)) - offset;
 
         for(int i = 0; i <= numSteps; i++)
         {
             HitResult hitResult = mc.currentWorld.checkBlockCollisionBetweenPoints(
-                    Vec3.getTempVec3(x, y, z),
-                    Vec3.getTempVec3(x - i * dx, y - i * dy, z - i * dz),
+                    Vec3.fromPool(x, y, z),
+                    Vec3.fromPool(x - i * dx, y - i * dy, z - i * dz),
                     false,
                     true,
                 false);
             if(hitResult != null)
             {
-                double distance = hitResult.location.distanceTo(Vec3.getTempVec3(x, y, z)) - offset;
+                double distance = hitResult.location.distanceTo(Vec3.fromPool(x, y, z)) - offset;
                 if (distance < 0) distance = 0;
                 cameraDistance = distance;
                 break;
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
index 42133bd5f..97717663d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
@@ -36,7 +36,7 @@ public interface ICamera
 
     default Vec3 getPosition(float partialTick)
     {
-        return Vec3.getTempVec3(getX(partialTick), getY(partialTick), getZ(partialTick));
+        return Vec3.fromPool(getX(partialTick), getY(partialTick), getZ(partialTick));
     }
 
     default Vec3 getPosition()
@@ -66,7 +66,7 @@ public interface ICamera
         float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
         float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
         float z = MathHelper.cos(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
-        return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
+        return Vec3.fromPool(x * xzLen, y, z * xzLen);
     }
 
     default Vec3 getRotationVector(float partialTick)
@@ -80,7 +80,7 @@ public interface ICamera
         float x = MathHelper.sin((float) (-yaw * toRads - Math.PI));
         float y = MathHelper.sin((float) (-pitch * toRads));
         float z = MathHelper.cos((float) (-yaw * toRads - Math.PI));
-        return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
+        return Vec3.fromPool(x * xzLen, y, z * xzLen);
     }
 
     default Vec3 getRotationVector()
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index b3158088a..1d53b34c9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -22,7 +22,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
             int handedNess = entity.owner.isLeftHanded() ? -1 : 1;
             float f11 = entity.owner.getSwingProgress(partialTick);
             float f12 = MathHelper.sin(MathHelper.sqrt_float(f11) * MathHelper.PI);
-            Vec3 vec3 = Vec3.getTempVec3(-0.75D * handedNess, -0.05D, 0.8D);
+            Vec3 vec3 = Vec3.fromPool(-0.75D * handedNess, -0.05D, 0.8D);
             vec3.rotateAroundX((-(entity.owner.xRotO + (entity.owner.xRot - entity.owner.xRotO) * partialTick) * MathHelper.PI) / 180F);
             vec3.rotateAroundY((-(entity.owner.yRotO + (entity.owner.yRot - entity.owner.yRotO) * partialTick) * MathHelper.PI) / 180F);
             vec3.rotateAroundY(f12 * 0.5F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index a4aa7d283..e39e9206d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -36,7 +36,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         double renderYaw = yaw;
         boolean doAFlip = false;
         if(vec3 != null) {
-//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.5, z), Vec3.getTempVec3(-(vec3.x - lerpX), -(vec3.y - lerpY), -(vec3.z - lerpZ)), 1.5, 1, 0, 0, 1);
+//            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.5, z), Vec3.fromPool(-(vec3.x - lerpX), -(vec3.y - lerpY), -(vec3.z - lerpZ)), 1.5, 1, 0, 0, 1);
             final double scalar = 0.3D;
             Vec3 forVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, scalar);
             Vec3 backVec = minecart.getPosOffs(lerpX, lerpY, lerpZ, -scalar);
@@ -47,8 +47,8 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
                 backVec = vec3;
             }
 
-//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.6, z), Vec3.getTempVec3(forVec.x - lerpX, forVec.y - lerpY, forVec.z - lerpZ), 1.5, 0, 1, 0, 1);
-//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.7, z), Vec3.getTempVec3(backVec.x - lerpX, backVec.y - lerpY, backVec.z - lerpZ), 1.5, 0, 0, 1, 1);
+//            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.6, z), Vec3.fromPool(forVec.x - lerpX, forVec.y - lerpY, forVec.z - lerpZ), 1.5, 0, 1, 0, 1);
+//            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.7, z), Vec3.fromPool(backVec.x - lerpX, backVec.y - lerpY, backVec.z - lerpZ), 1.5, 0, 0, 1, 1);
 
             renderX += vec3.x - lerpX;
             renderY += (forVec.y + backVec.y) / 2D - lerpY;
@@ -60,11 +60,11 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
                 lerpXRot = Math.atan(velVec.y) * 73D;
             }
 
-            final Vec3 realVecVec = Vec3.getTempVec3(minecart.xd, minecart.yd, minecart.zd);
+            final Vec3 realVecVec = Vec3.fromPool(minecart.xd, minecart.yd, minecart.zd);
 
             doAFlip = velVec.dotProduct(realVecVec) < 0;
 
-//            drawDebugVec(tessellator, Vec3.getTempVec3(x, y + 1.8, z), Vec3.getTempVec3(velVec.x, velVec.y, velVec.z), 1.5, 0, 1, 1, 1);
+//            drawDebugVec(tessellator, Vec3.fromPool(x, y + 1.8, z), Vec3.fromPool(velVec.x, velVec.y, velVec.z), 1.5, 0, 1, 1, 1);
         }
         GL11.glTranslated(renderX, renderY, renderZ);
         GL11.glRotated(180F - renderYaw, 0.0F, 1.0F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index c1de94d76..f06b4670c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -375,6 +375,11 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
             .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
             .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
             .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
+        addDispatch(new ItemModelStandard(Items.WAND_NBT, "minecraft")
+            .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, HANDHELD_FIRST_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.FIRST_PERSON_LEFT_HAND, HANDHELD_FIRST_PERSON_LEFT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_RIGHT_HAND, HANDHELD_THIRD_PERSON_RIGHT_HAND)
+            .setDisplayPos(DisplayPos.THIRD_PERSON_LEFT_HAND, HANDHELD_THIRD_PERSON_LEFT_HAND));
         addDispatch(new ItemModelStandard(Items.DOOR_STEEL, "minecraft"));
         addDispatch(new ItemModelPaintbrush(Items.PAINTBRUSH, "minecraft")
             .setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND,  new DisplayPos(1.13f/16f, 3.2f/16f, 1.13f/16f, 90, -90, 25, 0.68f, 0.68f, 0.68f))
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 63385c488..377bbd9a6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -8,6 +8,8 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
index 3e6a423ea..0fd4bcdfc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -88,9 +88,9 @@ public abstract class ChunkRenderer
             yRender = y - yRenderOffs;
             zRender = z - zRenderOffs;
             float f = 6F;
-            bb = AABB.getPermanentBB((float)x - f, (float)y - f, (float)z - f, (float)(x + sizeX) + f, (float)(y + sizeY) + f, (float)(z + sizeZ) + f);
+            bb = AABB.fromPool((float)x - f, (float)y - f, (float)z - f, (float)(x + sizeX) + f, (float)(y + sizeY) + f, (float)(z + sizeZ) + f).copyUnpooled();
             GL11.glNewList(lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
-            EntityRendererItem.renderFlatAABB(AABB.getTemporaryBB((float) xRenderOffs - f, (float) yRenderOffs - f, (float) zRenderOffs - f, (float)(xRenderOffs + sizeX) + f, (float)(yRenderOffs + sizeY) + f, (float)(zRenderOffs + sizeZ) + f));
+            EntityRendererItem.renderFlatAABB(AABB.fromPool((float) xRenderOffs - f, (float) yRenderOffs - f, (float) zRenderOffs - f, (float)(xRenderOffs + sizeX) + f, (float)(yRenderOffs + sizeY) + f, (float)(zRenderOffs + sizeZ) + f));
             GL11.glEndList();
             setDirty();
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 0afc1a740..5b0931dab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -53,7 +53,7 @@ public class TextureRegistry {
 
     public static @NotNull IconCoordinate getTexture(@NotNull String key){
         try {
-            return getTexture(NamespaceID.getTemp(key));
+            return getTexture(NamespaceID.fromPool(key));
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
@@ -63,11 +63,11 @@ public class TextureRegistry {
         final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
         if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
 
-        return atlas.getTexture(id, NamespaceID.getTemp(id.namespace(), id.value().substring(slashIndex + 1)));
+        return atlas.getTexture(id, NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
     }
     public static boolean hasTexture(@NotNull String key) {
         try {
-            return hasTexture(NamespaceID.getTemp(key));
+            return hasTexture(NamespaceID.fromPool(key));
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
@@ -77,7 +77,7 @@ public class TextureRegistry {
         final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
         if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
 
-        return atlas.textureMap.containsKey(NamespaceID.getTemp(id.namespace(), id.value().substring(slashIndex + 1)));
+        return atlas.textureMap.containsKey(NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
     }
     public static AtlasStitcher register(String id, AtlasStitcher atlas){
         stitcherMap.put(id, atlas);
@@ -104,8 +104,8 @@ public class TextureRegistry {
         for (String s : files) {
 //            System.out.println(s);
 
-            NamespaceID id = NamespaceID.getTemp(namespace, s.replace(".png", "").replace("//", "/"));
-            atlas.getTexture(NamespaceID.getTemp(id.namespace(), stitcherMapReverse.get(atlas) + "/" + id.value()), id);
+            NamespaceID id = NamespaceID.fromPool(namespace, s.replace(".png", "").replace("//", "/"));
+            atlas.getTexture(NamespaceID.fromPool(id.namespace(), stitcherMapReverse.get(atlas) + "/" + id.value()), id);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 283c34a26..1ef003815 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -205,7 +205,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
     @Override
     public boolean isVisible(@NotNull final TileEntitySign tileEntity, final @NotNull ICamera camera, final float partialTick) {
-        return camera.getFrustum().isVisible(AABB.getTemporaryBB(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.x + 1, tileEntity.y + 1, tileEntity.z + 1), partialTick);
+        return camera.getFrustum().isVisible(AABB.fromPool(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.x + 1, tileEntity.y + 1, tileEntity.z + 1), partialTick);
     }
 
     public static class BufferedTextMeshRenderer {
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
index d98f60e94..be3214445 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFX.java
@@ -67,7 +67,7 @@ public class WorldTypeFX {
     }
 
     public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
-        return Vec3.getTempVec3(1.0, 1.0, 1.0);
+        return Vec3.fromPool(1.0, 1.0, 1.0);
     }
 
     public float[] getSunriseColor(float timeOfDay, float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
index 5852c737a..cd90bba49 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXDrift.java
@@ -56,6 +56,6 @@ public class WorldTypeFXDrift extends WorldTypeFX{
         r *= f2 * 0.94F + 0.06F;
         g *= f2 * 0.94F + 0.06F;
         b *= f2 * 0.91F + 0.09F;
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
index 00c54f298..5ecd801fd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
+++ b/game/client/src/main/java/net/minecraft/client/render/worldtype/WorldTypeFXEmpty.java
@@ -25,7 +25,7 @@ public class WorldTypeFXEmpty extends WorldTypeFX{
         r *= f2 * 0.94F + 0.06F;
         g *= f2 * 0.94F + 0.06F;
         b *= f2 * 0.91F + 0.09F;
-        return Vec3.getTempVec3(r, g, b);
+        return Vec3.fromPool(r, g, b);
     }
 
     @Override
